.686			
.XMM
.model 	flat, stdcall
option 	casemap:none

include	c:\masm32\include\windows.inc
include	c:\masm32\include\kernel32.inc
include	c:\masm32\include\masm32.inc
include	c:\masm32\macros\macros.asm
include	c:\masm32\macros\timers.asm
includelib	c:\masm32\lib\kernel32.lib
includelib	c:\masm32\lib\masm32.lib

Main			proto

Lingo32c		proto :dword,:dword
strcmpQ		proto :dword,:dword

.data

	LOOP_COUNT	EQU	1000000		; 1M iterations per timing result

    align 4
    str1 db 777 dup (61h), 0
    align 4
    str2 db 401 dup (61h), 0


msgstr db "Cycles: %d", 0
SzlstrcmpOrg		DB  "lstrcmp - original: ",0
Szlstrcmpkunt0r	DB  "lstrcmp - kunt0r  : ",0
Szlstrcmplingo		DB  "lstrcmp - Lingo   : ",0
 retva  dd 0




.data?
    buff db 32 dup(?)



.code
Start:
	Invoke	Main
	Invoke	ExitProcess, 0
Main	Proc
	;print	chr$(" lstrcmp tests ",13,10)
	mov	eax, input(" Please terminate any high-priority tasks and press ENTER to begin.")
    	print	chr$(13,10,13,10," lstrcmp  Tests:",13,10,13,10)
; ------------------------------------------------------------------------------------------------------------------------------------------------------------  

; ------------------------------------------------------------------------------------------------------------------------------------------------------------  
comment * lstrcmp original *
	print	addr SzlstrcmpOrg	
	counter_begin	LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke lstrcmp, addr str1, addr str2
		mov	retva, eax
	counter_end
	print	ustr$(eax)
	print	chr$(" clocks; Return value: ")
	mov	eax, retva
	print	ustr$(eax)
	print	chr$(" ",13,10)
	invoke	Sleep, 250
; ------------------------------------------------------------------------------------------------------------------------------------------------------------  
comment * lstrcmp by kunt0rl *
	print	addr Szlstrcmpkunt0r	
	counter_begin	LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke strcmpQ, addr str1, addr str2
		mov	retva, eax
	counter_end
	print	ustr$(eax)
	print	chr$(" clocks; Return value: ")
	mov	eax, retva
	print	ustr$(eax)
	print	chr$(" ",13,10)
	invoke	Sleep, 250
; ------------------------------------------------------------------------------------------------------------------------------------------------------------  
comment * lstrcmp by lingo *
	print	addr Szlstrcmplingo
	counter_begin	LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke Lingo32c, addr str1, addr str2
		mov	retva, eax
	counter_end
	print	ustr$(eax)
	print	chr$(" clocks; Return value: ")
	mov	eax, retva
	print	ustr$(eax)
	print	chr$(" ",13,10)
	invoke	Sleep, 250
; ------------------------------------------------------------------------------------------------------------------------------------------------------------  
mov	eax, input(13,10," Press ENTER to exit...")
	ret
Main	EndP


; ------------------------------------------------------------------------------------------------------------------------------------------------------------  
comment 		* BM by kunt0r *
align 		16
;##########################################################################
OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

strcmpQ proc strn1:dword, strn2:dword
	push ebx
    push edi
    push esi
    mov esi, dword ptr [esp+16]
    mov edi, dword ptr [esp+20]
tp: mov ecx, dword ptr [esi]
    mov edx, dword ptr [edi]
    mov eax, ecx
    mov ebx, edx
    add esi, 4
    add edi, 4
    sub ecx, 16843009
    sub edx, 16843009
    and ecx, 2155905152
    jnz p1
    and edx, 2155905152
    jnz p2
    sub eax, ebx
    jz tp
    pop esi
    pop edi
    pop ebx
    ret 8
p1: not eax
    and ecx, eax
    jz tp
    test cl, cl
    jnz c1
    test ch, ch
    jnz c2
    test ecx, 16711680
    jnz c3
    jmp c4
p2: not ebx
    and edx, ebx
    jz tp
    test dl, dl
    jnz c1
    test dh, dh
    jnz c2
    test edx, 16711680
    jnz c3
    jmp c4
c1: movzx eax, byte ptr [esi-4]
    movzx ebx, byte ptr [edi-4]
    sub al, bl
    pop esi
    pop edi
    pop ebx
    ret 8
c2: movzx eax, word ptr [esi-4]
    movzx ebx, word ptr [edi-4]
    sub ax, bx
    pop esi
    pop edi
    pop ebx
    ret 8
c3: mov eax, dword ptr [esi-4]
    mov ebx, dword ptr [edi-4]
    and eax, 16777215
    and ebx, 16777215
    sub eax, ebx
    pop esi
    pop edi
    pop ebx
    ret 8
c4: mov eax, dword ptr [esi-4]
    mov ebx, dword ptr [edi-4]
    sub eax, ebx
    pop esi
    pop edi
    pop ebx
    ret 8
strcmpQ endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
;...........................................................................................
comment * lstrcmp by Lingo *
Align	16
db			8Dh, 64h, 24h, 0, 90h
Lingo32c			proc		lpString1:DWORD, lpString12:DWORD
						mov		eax, [esp+4]		; eax-> lpString1
						mov		edx, 80808080h
						mov		ecx, [esp+8]		; ecx-> lpString2
						mov		[esp+4], esi		; save  esi register
						mov		esi, eax             ;  esi-> lpString1
						mov		[esp+8], edi		; save  edi register
						xor		eax, eax				; eax->index
   						mov		edi, [esi]
@@:
						cmp		edi, [ecx+eax]
						jne		@@3s
						add		edi, 0FEFEFEFFh
						add		eax, 4
						test		edx, edi
						mov		edi, [esi+eax]
						je			@b

						test		byte ptr [esi+eax-4], 0FFh
						je			@@2s4 
@@1s:
						test		byte ptr [esi+eax-3], 0FFh
						je			@@2s3 
						test		byte ptr [esi+eax-2], 0FFh
						je			@@2s2
						test		byte ptr [esi+eax-1], 0FFh
						je			@@2s1
						nop
@@:
						cmp		edi, [ecx+eax]
						jne		@@3s
			            and		edi, 07F7F7F7FH
						add		eax, 4
						add		edi, 0FEFEFEFFh
            			test		edx, edi
						mov		edi, [esi+eax]
            			je 			@b
 						test		byte ptr [esi+eax-4], 0FFh
                        jne		@@1s
@@2s4: 
						sub		eax, 4
@@3s:
						movzx	edx, byte ptr [esi+eax]  ; esi-> lpString1
						add		eax, 1
						cmp		[ecx+eax-1], dl			   ; ecx-> lpString2
						jne		@@4s
						test		edx, edx
						jne		@@3s
						mov		esi, [esp+4]		; restore  esi register
						xor		eax, eax 			; 2 strings are equal
						mov		edi, [esp+8]		; restore  edi register
						ret		8
align 16
@@2s3:
					   sub		eax, 3
						jne		@@3s
@@2s2:
						sub		eax, 2
						jne		@@3s
@@2s1:
					   sub		eax, 1
						jne		@@3s
align 16
@@4s:
						mov		esi, [esp+4]		; restore  esi register
						ja			@@5s
    					mov		edi, [esp+8]		; restore  edi register
						mov		eax, 1	 			; 2 string is less then 1 string
						ret		8
@@5s:
						mov		edi, [esp+8]		; restore  edi register
 						or			eax,-1	 			; 1 string is less then 2nd string
						ret		8
Lingo32c			endp
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

        
End	Start




